C.**************************************************************************
C     SUBROUTINE FOR THE MOVEMENTS OF THE PARTICLES IN THE CRYSTAL
C.**************************************************************************
      SUBROUTINE CRYST(Length,layerflag,PROC,
     +          L_chan,tchan,Alayer,ymin,ymax,Rcurv,s_length,IS,NAM, 
     +	        xpcrit0,xpcrit,Rcrit,ratio,C_orient,miscut,Cry_length, 
     +	        ZN,C_xmax,C_ymax,x,xp,y,yp,PC,s,Chann,xp_rel,Ang_rms,
     +	        Ang_avr,Vcapt,Dechan,DES,DLYI,DLRI,eUm,AI)
	      


c      SUBROUTINE CRYST(Length,layerflag,crypara,partpara,crysparaDes,
c     +          crysparaDlri,
c     +          crysparaDlyi,crysparaeUmIS,crysparaAIIS,PROC)
C      SUBROUTINE CRYST(IS,x,xp,y,yp,PC,Length,p1,p2,p3,p4,p5,p6,p7,PROC,LAYERFLAG,Chann,Dechan,L_chan)

c
C     Simple tranport protons in crystal 2
C-----------------------------------------------------------C
C      J -   number of element                              C
C      S - longitudinal coordinate      
C      IS -   number of substance 1-4: Si,W,C,Ge(110)       C
C      x,xp,y,yp - coordinates at input of crystal          C
C      PC -   momentum of particle*c [GeV]                  C
C      W  -   weigth of particle                            C
C-----------------------------------------------------------C
C
C
      IMPLICIT none
c     
C
C
      integer LAYERFLAG
      double precision p1, p2,p3,p4 !common block: Cry_length, Rcurv,C_xmax,C_ymax
      double precision p5 !common block: Alayer
      integer p6 !common block: C_orient
C
      double precision p7 !common block: miscut 
      CHARACTER*50 p8 !common block: PROC

      
      
      
      double precision Rcurv,Length,C_xmax,C_ymax !crystal geometrical parameters
                                                  ! [m],[m],[m],[m],[rad]
      double precision ymax,ymin       !crystal geometrical parameters 
      double precision s_length             !element length along s
      double precision Alayer               !amorphous layer [m]
      integer C_orient                      !crystal orientation 
      integer IS                            !index of the material
c      integer counter 
      double precision  DLRI(4),DLYI(4),AI(4),DES(4)!cry parameters:see line~270
      double precision DESt                  ! Daniele: changed energy loss by ionization now calculated and not tabulated
      integer NAM,ZN                        !switch on/off the nuclear 
                                            !interaction (NAM) and the MCS (ZN)
      double precision x,xp,y,yp,PC         !coordinates of the particle 
                                            ![m],[rad],[m],[rad],[GeV]
      double precision x0,y0                !coordinates of the particle [m]
      double precision s                    !long coordinates of the particle [m]
      double precision a_eq,b_eq,c_eq,Delta !second order equation param.
      double precision Ang_rms, Ang_avr     !Volume reflection mean angle [rad]
      double precision c_v1                 !fitting coefficient 
      double precision c_v2                 !fitting coefficient 
      double precision Dechan               !probability for dechanneling 
      double precision Lrefl, Srefl         !distance of the reflection point [m] 
      double precision Vcapt                !volume capture probability
      double precision Chann                !channeling probability
      double precision N_atom               !probability for entering 
                                            !channeling near atomic planes
      double precision Dxp                  !variation in angle
      double precision xpcrit               !critical angle for curved crystal[rad]
      double precision xpcrit0              !critical angle for str. crystal [rad]
      double precision Rcrit                !critical curvature radius [m]
      double precision ratio                !x=Rcurv/Rcrit
      double precision Cry_length
      double precision TLdech2              !tipical dechanneling length(1) [m]
      double precision TLdech1              !tipical dechanneling length(2) [m]
      double precision tdech, Ldech,Sdech   !angle, lenght, and S coordinate 
                                            !of dechanneling point  
      double precision Rlength, Red_S       !reduced length/s coordinate 
                                            !(in case of dechanneling)
      double precision Am_length            !Amorphous length 
      double precision Length_xs, Length_ys !Amorphous length 
      double precision miscut               !miscut angle in rad
      double precision L_chan, tchan
      double precision xp_rel               !xp-miscut angle in mrad
c      REAL*4 RNDM                           !random numbers
c      REAL*4      rndm4
c      REAL*4      RAN_GAUSS
      double precision RNDM                           !random numbers
      double precision  rndm4
      double precision  RAN_GAUSS
      double precision eUm(4)                !maximum potential
      CHARACTER*50 PROC        !string that contains the physical process  

      double precision rho(4),z(4),Ime(4) !Daniele: material parameters for dE/dX calculation  
      double precision k,re,me,mp !Daniele: parameters for dE/dX calculation (const,electron radius,el. mass, prot.mass)
      double precision enr,mom,betar,gammar,bgr !Daniele: energy,momentum,beta relativistic, gamma relativistic
      double precision Tmax,plen !Daniele: maximum energy tranfer in single collision, plasma energy (see pdg)
      double precision anuc_cry2(4),aTF,dP,const_dech,u1,xpin,ypin


      real emr_cry(4)

C     global variables shared by this file and the main file 
C     "crystaltrack_dan.f".
C      common /Par_Cry1/ Cry_length, Rcurv,C_xmax,C_ymax,Alayer,C_orient
C      common /miscut/ miscut
C      common /Proc2/PROC

C     global variables shared by the subroutines in this file.
C      COMMON/NPC/     NAM,ZN                 
C      COMMON/CRYS/    DLRI,DLYI,AI,DES       
C      COMMON/eUc/     eUm  !
      common/ion/rho,z,Ime,k,re,me,mp,anuc_cry2,emr_cry
      common/ion2/enr,mom,gammar,betar,bgr,Tmax,plen
      common/dech/aTF,dP,u1

c     global variables shared by this file and the main file
c     "crystaltrack_dan.f"
c      Cry_length=p1
c      Rcurv=p2
c      C_xmax=p3
c      C_ymax=p4
c     Alayer=p5
c      C_orient=p6
c      miscut=p7

      IS = IS + 1; 
    
c      common/utils/ counter
C
c
      NAM=1 !switch on/off the nuclear interaction (NAM) and the MCS (ZN)
      ZN=1

!-------------Daniele: dE/dX and dechanneling length calculation--------------------


      enr=PC*1.0d3 !GeV -> MeV
      mom=(enr*enr-mp*mp)**0.5 !p momentum [MeV/c]
      gammar=enr/mp
      betar=mom/enr
      bgr=betar*gammar

      Tmax=(2.0d0*me*bgr**2)/(1.0d0+2*gammar*me/mp+(me/mp)**2) ![MeV]

      plen=((rho(IS)*z(IS)/anuc_cry2(IS))**0.5)*28.816d-6 ![MeV]

c      DESt=((k*z(IS))/(anuc_cry2(IS)*betar**2))*
c     + (0.5*log((2.0d0*me*bgr*bgr*Tmax)/(Ime(IS)*Ime(IS)))
c     + -betar**2.0-log(plen/Ime(IS))-log(bgr)+0.5);

c      DESt=DESt*rho(IS)*0.1 ![GeV/m]

      const_dech=(256.0/(9.0*(4.D0*DATAN(1.D0))**2))*
     + (1.0/(log(2.0*me*gammar/Ime(IS))-1.0))*((aTF*dP)/(re*me))  ![m/MeV]

      const_dech=const_dech*1.0d3    ![m/GeV]

!      write(*,*)DESt, const_dech

!----------------------------------------------------------


c      miscut=0.001000
c 
c      write(*,*)"last miscut angle =",miscut
c      write(*,*) 'enter crystal subroutine'
c      write(*,*) 'particle energy Gev :', PC
c      write(*,*) 'x_initial :', x
c      write(*,*) 'Length [m]:', Length
c      write(*,*) 'Random:', rndm4()
c      write(*,*)'xp',xp,'x',x , 's', s
      s=0
      s_length=Rcurv*(sin(length/Rcurv)) !
      L_chan=length

C******************************************
C Start to call the crystal routine
C  the same as: SimCrys::bases() in
C  simcrys.cc
C
C   Commented by Jianfeng Zhang @ LAL, 29/04/2014
C
C******************************************
C     
C-----------SimCrys::bases() in simcrys.cc
C
C  Commented by Jianfeng Zhang @ LAL, 29/04/2014

      if ( miscut .lt. 0 
     &     .and. x .gt. 0 !should be useless 
     &     .and. x .lt. -length*tan(miscut)) then
            L_chan=-x/sin(miscut)
      endif
      tchan=L_chan/Rcurv
      xp_rel=xp-miscut
C----------------------------


C     
C-----------Crystal::Crystal() in crystal.cc
C
C  Commented by Jianfeng Zhang @ LAL, 29/04/2014

c  FIRST CASE: p don't interact with crystal
      ymin = - C_ymax/2 
      ymax =  C_ymax/2
C--------------------------------------------

C     
C-----------SimCrys::cross() in simcrys.cc
C
C  Commented by Jianfeng Zhang @ LAL, 29/04/2014

      IF (y.LT.ymin .or. y.GT.ymax .or. x.gt.C_xmax) THEN
      
        write(*,*) "y = ", y
        write(*,*) "ymin = ", ymin
        write(*,*) "ymax = ", ymax
        write(*,*) "x = ", x
        write(*,*) "C_xmax = ", C_xmax
        
        x = x+xp*s_length
        y = y+yp*s_length
        PROC='out'
        GOTO 111

C---------------------------


C--------------------------------------------

C     
C-----------SimCrys::layer() in simcrys.cc
C
C  Commented by Jianfeng Zhang @ LAL, 29/04/2014

c SECOND CASE: p hits the amorphous layer        
      ELSEIF ( (x.LT.Alayer) .or.  ((y-ymin).LT.Alayer) .or. 
     1  ((ymax-y).lt.Alayer)  ) THEN
        x0=x
        y0=y
        a_eq=(1+(xp)**2)
        b_eq=(2*(x)*(xp)-2*(xp)*Rcurv)
        c_eq=(x)**2-2*(x)*Rcurv
        Delta=b_eq**2-4*a_eq*c_eq
        s=((-b_eq+sqrt(Delta))/(2*a_eq)) 

        if (s .ge. s_length) s=s_length

        x=(xp)*s+x0
        Length_xs=sqrt((x-x0)**2+s**2)

        if ( (yp .ge.0 .and. (y+yp*s).le.ymax)) then
          Length_ys = yp*Length_xs
        elseif (yp.lt.0 .and. (y+yp*s).ge. ymin) then
          Length_ys = yp*Length_xs
        else
          s=(ymax-y)/yp
          Length_ys = sqrt((ymax-y)**2+s**2)
          x=x0+xp*s
          Length_xs=sqrt((x-x0)**2+s**2)
        endif
        Am_length   = sqrt(Length_xs**2+Length_ys**2)       
        s=s/2
        x=x0+xp*s
        y=y0+yp*s
        PROC='AM'
!        CALL MOVE_AM_(IS,NAM,Am_Length,DES(IS),DLYi(IS),DLRi(IS),xp,yp
!     + ,PC)
        CALL CALC_ION_LOSS(IS,PC,AM_Length,DESt)
        CALL MOVE_AM_(IS,NAM,Am_Length,DESt,DLYi(IS),DLRi(IS),xp,yp
     + ,PC)
        x=x+xp*(s_length-s)
        y=y+yp*(s_length-s)

        LAYERFLAG = 0;
        GOTO 111
      ELSEIF ((x.GT.(C_xmax-Alayer)) .and. x.LT.(C_xmax)  ) THEN
        PROC='AM'
!        CALL MOVE_AM_(IS,NAM,s_length,DES(IS),DLYi(IS),DLRi(IS), xp,yp
!     + ,PC)
        CALL CALC_ION_LOSS(IS,PC,s_length,DESt)
        CALL MOVE_AM_(IS,NAM,s_length,DESt,DLYi(IS),DLRi(IS), xp,yp
     + ,PC)
        WRITE(*,*)'Fix here!'
        LAYERFLAG = 0;
        GOTO 111
      END IF


C--------------------------------------------

C     
C-----------SimCrys::parameters() in simcrys.cc
C
C  Commented by Jianfeng Zhang @ LAL, 29/04/2014
C
c
c THIRD CASE: the p interacts with the crystal.      
C. Define typical angles/probabilities for orientation 110
c
      xpcrit0 = (2.e-9*eUm(IS)/PC)**0.5       ! critical angle (rad) for 
                                              ! straight crystals
      Rcrit  = PC/(2.e-6*eUm(IS))*AI(IS)      ! critical curvature radius [m] 
                                              ! if R>Rcritical=>no channeling is
                                              ! possible (ratio<1)
      ratio = Rcurv/Rcrit                     ! parameter Rcry/Rcritical
c      write(*,*) "Critical Radius: ",Rcrit
c       write(*,*) "eUm(IS): ", eUm(IS)
c       write(*,*)  "PC: ", PC
c       write(*,*) "xpcrit0: ", xpcrit0
      xpcrit = xpcrit0*(Rcurv-Rcrit)/Rcurv    ! critical angle for curved crystal
c----------------valentina approx-----------   
c      xpcrit = xpcrit0*(1-(Rcrit/Rcurv))**0.5
c      write(*,*)(Rcurv-Rcrit)/Rcurv,(1-(Rcrit/Rcurv))**0.5  

                                              ! NB: if ratio<1 => xpcrit<0
      c_v1 = 1.7                              ! fitting coefficient ??!
      c_v2 = -1.5                             ! fitting coefficient ???
      if (ratio .le. 1.) then                 ! case 1:no possibile channeling
        Ang_rms = c_v1*0.42*xpcrit0*sin(1.4*ratio)  ! rms scattering
        Ang_avr = c_v2*xpcrit0*0.05*ratio           ! average angle reflection
        Vcapt = 0.0                                 ! probability of VC
        elseif (ratio .le. 3) then              ! case 2: strongly bent xstal
          Ang_rms = c_v1*0.42*xpcrit0*sin(1.571*0.3*ratio+0.85)! rms scattering
          Ang_avr = c_v2*xpcrit0*(0.1972*ratio-0.1472)  ! avg angle reflection
c          Vcapt   = 0.01*(ratio-0.7)/(PC**2)
          Vcapt   = 0.0007*(ratio-0.7)/PC**0.2 !correction by sasha drozdin/armen    
          !K=0.00070 is taken based on simulations using CATCH.f (V.Biryukov)   
        else                                       ! case 3: Rcry >> Rcrit
          Ang_rms = c_v1*xpcrit0*(1./ratio)        !   
          Ang_avr = c_v2*xpcrit0*(1.-1.6667/ratio) ! average angle for VR
c          Vcapt = 0.01*(ratio-0.7)/(PC**2)        ! probability for VC  
          Vcapt = 0.0007*(ratio-0.7)/PC**0.2  !correction by sasha drozdin/armen
          ! K=0.0007 is taken based on simulations using CATCH.f (V.Biryukov)
      endif
cc----------------valentina approx-----------   
c      Ang_avr=-(xpcrit+xpcrit0) 
c      Ang_rms=(xpcrit0-xpcrit)/2 
cc-----------end valentina approx--------------

c      write(*,*) "Rcrit" , Rcrit,"Rcurv",Rcurv,
c     c "Ratio: ",ratio,"average VR angle:", ang_avr*1e6,"+-",           
c     c ang_rms*1e6, "ang crit:", xpcrit0*1e6,xpcrit*1e6
c      
      if(C_orient .eq. 2) then
        Ang_avr = Ang_avr * 0.93                     ! for (111)
        Ang_rms = Ang_rms * 1.05
        xpcrit  = xpcrit * 0.98
      endif 

C---------------------------




C--------------------------------------------

C     
C-----------SimCrys::channel() in simcrys.cc
C
C  Commented by Jianfeng Zhang @ LAL, 29/04/2014
c
C. case 3-1: channeling
      IF (abs(xp_rel) .lt. xpcrit) THEN              ! if R' < R'c (ok CH) (1)
        Chann  = (xpcrit**2-xp_rel**2)**0.5/xpcrit0  ! probability of CH/VC
        N_atom = 0.1                                 ! probability of entering 
                                                     ! close to atomic planes
        IF (rndm4() .le. Chann) then      ! if they can channel: 2 options
                                          ! option 1:channeling
c          TLdech1= 0.00054*PC*(1.-1./ratio)**2 ! calculate dechanneling length
!          TLdech1= 0.0005*PC*(1.-1./ratio)**2 !calculate tipical dech. length(m)
          TLdech1= const_dech*PC*(1.-1./ratio)**2 !Daniele: updated calculate tipical dech. length(m)
          IF (rndm4() .le. N_atom) then
c            TLdech1= 0.000004*PC*(1.-1./ratio)**2! calculate tipical dechanneling
                                                  !length near atomic planes(m)
           !next line new from sasha
!            TLdech1= 2.0e-6*PC*(1.-1./ratio)**2  ! dechanneling length (m) 
            TLdech1= (const_dech/200.d0)*PC*(1.-1./ratio)**2  ! Daniele: updated dechanneling length (m)

                               !for short crystal for high amplitude particles 
          ENDIF  

c          TLdech1=TLdech1/100 !!!!CHECK
          
          Dechan = -log(rndm4())                 ! probability of dechanneling
          Ldech  = TLdech1*Dechan                ! actual dechan. length
                     ! careful: the dechanneling lentgh is along the trajectory 
                     ! of the particle -not along the longitudinal coordinate...   
          if(Ldech .LT. L_chan) THEN    
           PROC='DC'                  !                               
            Dxp= Ldech/Rcurv             ! change angle from channeling [mrad]
            Sdech=Ldech*cos(miscut+0.5*Dxp)

            x  = x+ Ldech*(sin(0.5*Dxp+miscut))   ! trajectory at channeling exit
            xp = xp + Dxp + 2.0*(rndm4()-0.5)*xpcrit
            y= y + yp * Sdech 
            CALL CALC_ION_LOSS(IS,PC,Ldech,DESt)
            PC = PC - 0.5*DESt*Ldech          ! energy loss to ionization while in CH [GeV]

            x = x + 0.5*(s_length-Sdech)*xp
            y = y + 0.5*(s_length-Sdech)*yp

            CALL CALC_ION_LOSS(IS,PC,s_length-Sdech,DESt)
            CALL 
!     +MOVE_AM_(IS,NAM,s_length-Sdech,DES(IS),DLYi(IS),DLRi(IS),xp,yp,PC)
     +MOVE_AM_(IS,NAM,s_length-Sdech,DESt,DLYi(IS),DLRi(IS),xp,yp,PC)
           !next line new from sasha
!            PC = PC - 0.5*DES(IS)*y          ! energy loss to ionization [GeV]
            x = x + 0.5*(s_length-Sdech)*xp
            y = y + 0.5*(s_length-Sdech)*yp
          else   !channeling                  
            PROC='CH'
            xpin=XP
            ypin=YP

c            write(*,*) PROC

            CALL MOVE_CH_(IS,NAM,L_chan,X,XP,YP,PC,Rcurv,Rcrit)  !daniele:check if a nuclear interaction happen while in CH

c            write(*,*) PROC

            if(PROC(1:2).ne.'CH')then             !daniele: if an nuclear interaction happened, move until the middle with initial xp,yp
            x = x + 0.5 * L_chan * xpin           !then propagate until the "crystal exit" with the new xp,yp
            y = y + 0.5 * L_chan * ypin           !accordingly with the rest of the code in "thin lens approx"
            x = x + 0.5 * L_chan * XP
            y = y + 0.5 * L_chan * YP
            CALL CALC_ION_LOSS(IS,PC,Length,DESt)
            PC = PC - DESt*Length       ! energy loss to ionization [GeV]
            else
            Dxp= L_chan/Rcurv + 0.5*RAN_GAUSS(1.)*xpcrit ! change angle[rad]
            xp = Dxp
            !next line new from sasha
            x  = x+ L_chan*(sin(0.5*Dxp+miscut)) ! trajectory at channeling exit
c            xp = xp + Dxp + 2.0*(rndm4()-0.5)*xpcrit  
            y = y + s_length * yp
c            !next line new from sasha
!            PC = PC - 0.5*DES(IS)*Length       ! energy loss to ionization [GeV]
            CALL CALC_ION_LOSS(IS,PC,Length,DESt)
            PC = PC - 0.5*DESt*Length       ! energy loss to ionization [GeV]
            endif
          endif                     
        ELSE                                   !option 2: VR
                                               ! good for channeling
                                               ! but don't channel         (1-2)
          PROC='VR'                            !volume reflection at the surface 
c          Dxp=0.5*(xp_rel/xpcrit+1)*Ang_avr
c          xp=xp+Dxp+Ang_rms*RAN_GAUSS(1.)
            !next line new from sasha
          
c          write(*,*) "y = ", y
c           write(*,*) "before enter VR: x = ", x, "  xp = ",xp
c           write(*,*) "y = ",y, "yp = ", yp, "PC = ", PC
            
          xp=xp+0.45*(xp/xpcrit+1)*Ang_avr
          x = x + 0.5*s_length * xp
          y = y + 0.5*s_length * yp 
!          CALL MOVE_AM_(IS,NAM,s_length,DES(IS),DLYi(IS),DLRi(IS), 
!     +      xp ,yp,PC)
          CALL CALC_ION_LOSS(IS,PC,s_length,DESt)
          CALL MOVE_AM_(IS,NAM,s_length,DESt,DLYi(IS),DLRi(IS), 
     +      xp ,yp,PC)
     
c          write(*,*) "after enter VR: x = ", x, "  xp = ",xp
c          write(*,*) "y = ",y, "yp = ", yp, "PC = ", PC
          
          x = x + 0.5*s_length * xp
          y = y + 0.5*s_length * yp 
        ENDIF       

C------------------------------                             !           
C
C
C--------------------------------------------
C     
C-----------SimCrys::reflection() in simcrys.cc
C
C  Commented by Jianfeng Zhang @ LAL, 29/04/2014

c case 3-2: no good for channeling. check if the  can VR
      ELSE                                       
        Lrefl =  (xp_rel)*Rcurv                  ! distance of refl. point [m]
c        Srefl = sin(xp) * Lrefl
        Srefl = sin(xp_rel/2+miscut) * Lrefl
        if(Lrefl .gt. 0. .and. Lrefl .lt. Length) then  
                ! VR point inside
                !2 options: volume capture and volume reflection
          IF (rndm4() .gt. Vcapt .or. ZN. eq. 0.) THEN   !opt. 1: VR
           PROC='VR'
           
            x = x + xp * Srefl
            y = y + yp * Srefl
            Dxp= Ang_avr 
            xp = xp + Dxp + Ang_rms*RAN_GAUSS(1.)
            x = x + 0.5* xp * (s_length - Srefl)
            y = y + 0.5* yp * (s_length - Srefl)     !       
!            CALL MOVE_AM_(IS,NAM,s_length-Srefl,DES(IS),DLYi(IS),
!     +          DLRi(IS),xp ,yp,PC)

c            write(*,*) "before enter VR: x = ", x, "  xp = ",xp
c            write(*,*) "y = ",y, "yp = ", yp, "PC = ", PC
           
            CALL CALC_ION_LOSS(IS,PC,s_length-Srefl,DESt)
            
c            write(*,*) "before enter VR: x = ", x, "  xp = ",xp
c            write(*,*) "y = ",y, "yp = ", yp, "PC = ", PC
c            write(*,*) "IS = ", IS, " NAM = ", NAM
c            write(*,*)  "s_length-Srefl = ",s_length-Srefl
c            write(*,*) "DESt = ", DESt, " DLYi(IS) = ", DLYi(IS)
c            write(*,*) "DLRi(IS) = ", DLRi(IS)
            
            CALL MOVE_AM_(IS,NAM,s_length-Srefl,DESt,DLYi(IS),
     +          DLRi(IS),xp ,yp,PC)
     
c            write(*,*) "after enter VR: x = ", x, "  xp = ",xp
c            write(*,*) "y = ",y, "yp = ", yp, "PC = ", PC
           
            x = x + 0.5 * xp * (s_length - Srefl)
            y = y + 0.5 * yp * (s_length - Srefl)    

        ELSE                                      !opt 2: VC
            x = x + xp * Srefl
            y = y + yp * Srefl
c            TLdech2= 0.00011*PC**0.25*(1.-1./ratio)**2 ! dechanneling length(m)
c            Dechan = log(1.-rndm4())
c            Ldech  = -TLdech2*Dechan
           !next 2 lines new from sasha - different dechanneling
           !probability
 !           TLdech2= 0.01*PC*(1.-1./ratio)**2   ! typical dechanneling length(m)
 !           Ldech  = 0.005*TLdech2*(sqrt(0.01-log(rndm4())) -0.1)**2 ! DC length
            TLdech2= (const_dech/10.0d0)*PC*(1.-1./ratio)**2   ! Daniele: updated typical dechanneling length(m)
            Ldech  = TLdech2*(sqrt(0.01-log(rndm4())) -0.1)**2 ! daniele: updated DC length
            tdech=Ldech/Rcurv
            Sdech=Ldech*cos(xp+0.5*tdech)
            IF(Ldech .LT. (Length-Lrefl)) then    
              PROC='DC'
              Dxp= Ldech/Rcurv + 0.5*ran_gauss(1)*xpcrit
              x  = x+ Ldech*(sin(0.5*Dxp+xp))   ! trajectory at channeling exit
              y = y + Sdech * yp 
              xp =  Dxp
              Red_S = s_length-Srefl -Sdech        
              x = x + 0.5 * xp * Red_S
              y = y + 0.5 * yp * Red_S
              CALL CALC_ION_LOSS(IS,PC,Srefl,DESt)                     
              PC=PC - DESt * Srefl !Daniele: "added" energy loss before capture
              CALL CALC_ION_LOSS(IS,PC,Sdech,DESt)
              PC=PC - 0.5 * DESt * Sdech !Daniele: "added" energy loss while captured
!              CALL MOVE_AM_(IS,NAM,Red_S,DES(IS),DLYi(IS),DLRi(IS),
!     +          xp,yp,PC)
              CALL CALC_ION_LOSS(IS,PC,Red_S,DESt)
              CALL MOVE_AM_(IS,NAM,Red_S,DESt,DLYi(IS),DLRi(IS),
     +          xp,yp,PC)
              x = x + 0.5 * xp * Red_S
              y = y + 0.5 * yp * Red_S                   
            else                               
              PROC='VC'
              Rlength = Length-Lrefl
              tchan = Rlength / Rcurv 
              Red_S=Rlength*cos(xp+0.5*tchan)
              CALL CALC_ION_LOSS(IS,PC,Lrefl,DESt)
              PC=PC - DESt*Lrefl  !Daniele: "added" energy loss before capture    
              xpin=XP
              ypin=YP
              CALL MOVE_CH_(IS,NAM,Rlength,X,XP,YP,PC,Rcurv,Rcrit)  !daniele:check if a nuclear interaction happen while in CH

              if(PROC(1:2).ne.'VC')then             !daniele: if an nuclear interaction happened, move until the middle with initial xp,yp
              x = x + 0.5 * Rlength * xpin           !then propagate until the "crystal exit" with the new xp,yp
              y = y + 0.5 * Rlength * ypin           !accordingly with the rest of the code in "thin lens approx"
              x = x + 0.5 * Rlength * XP
              y = y + 0.5 * Rlength * YP
              CALL CALC_ION_LOSS(IS,PC,Rlength,DESt)
              PC=PC - DESt*Rlength 
              else
              Dxp = (Length-Lrefl)/Rcurv 
              x  = x+ sin(0.5*Dxp+xp)*Rlength     ! trajectory at channeling exit
              y = y + red_S * yp
              xp =  Length/Rcurv + 0.5*ran_gauss(1)*xpcrit ! [mrad]
              CALL CALC_ION_LOSS(IS,PC,Rlength,DESt)
              PC=PC - 0.5*DESt*Rlength  !Daniele: "added" energy loss once captured    
              endif
            endif                       
          ENDIF                        
C.  case 3-3: move in amorphous substance (big input angles)---------------
        else                          
           PROC='AM'
           x = x + 0.5 * s_length * xp
           y = y + 0.5 * s_length * yp
          if(ZN .gt. 0) then                        
!           CALL MOVE_AM_(IS,NAM,s_length,DES(IS),DLYi(IS),DLRi(IS), 
!     +          xp,yp,PC)
           CALL CALC_ION_LOSS(IS,PC,s_length,DESt)
           CALL MOVE_AM_(IS,NAM,s_length,DESt,DLYi(IS),DLRi(IS), 
     +          xp,yp,PC)
          endif
          x = x + 0.5 * s_length * xp
          y = y + 0.5 * s_length * yp            
        endif                                 
       ENDIF                                 
C---------------------------
C
C
C     print the crystal parameters to an external file
       open(unit=833,file='crys_para_check.dat')
     
c      if (counter .eq. 0) then
111   write(833,*)'crystal parameters:\n Length:',Length, '\n Rcurv:'
     + , Rcurv ,'\n Critical Radius:', Rcrit, 'ratio',ratio             +
     +, '\n Critical angle for straight:',                              +
     + xpcrit0,'\n critical angle for curved crystal:', xpcrit,' \n Leng+
     +th:', Length, '\n xmax:', C_xmax, ' ymax:', ymax, '  C_orient: '  +
     +, C_orient                                                        +
     +, '\n Avg angle reflection:', Ang_avr, '\n full channeling angle: +
     +',(Length/Rcurv) 
c      counter=1
c      endif
c      
c      WRITE(*,*)'Crystal process: ',PROC
c      write(*,*)'xp_final :', xp
c      WRITE(*,*)'Crystal process: ',PROC,'Chann Angle',Ch_angle/1000,   +
c     1'Critical angle: ', xpcrit/1000
c     2 DLRI(IS),DLYI(IS),AI(IS),DES(IS),eUm(IS),IS,ZN,NAM,C_orient     !,W

      close(833)
      END

C.**************************************************************************
C     subroutine for the calculazion of the energy loss by ionization
C.**************************************************************************
      SUBROUTINE CALC_ION_LOSS(IS,PC,DZ,EnLo)

      IMPLICIT none
      integer IS
      double precision PC,DZ,EnLo
      double precision rho(4),z(4),Ime(4) !Daniele: material parameters for dE/dX calculation  
      double precision k,re,me,mp !Daniele: parameters for dE/dX calculation (const,electron radius,el. mass, prot.mass)
      double precision enr,mom,betar,gammar,bgr !Daniele: energy,momentum,beta relativistic, gamma relativistic
      double precision Tmax,plen !Daniele: maximum energy tranfer in single collision, plasma energy (see pdg)
      double precision anuc_cry2(4)
      real emr_cry(4)
      double precision thl,Tt,cs_tail,prob_tail
      double precision ranc
c      REAL*4 RNDM4
      double precision RNDM4

      common/ion/rho,z,Ime,k,re,me,mp,anuc_cry2,emr_cry
      common/ion2/enr,mom,gammar,betar,bgr,Tmax,plen


       thl= 4.0d0*k*z(IS)*DZ*100.0d0*rho(IS)/(anuc_cry2(IS)*betar**2) ![MeV]

       EnLo=((k*z(IS))/(anuc_cry2(IS)*betar**2))*
     + (0.5*log((2.0d0*me*bgr*bgr*Tmax)/(Ime(IS)*Ime(IS)))
     + -betar**2.0-log(plen/Ime(IS))-log(bgr)+0.5);

       EnLo=EnLo*rho(IS)*0.1*DZ ![GeV]

       Tt=EnLo*1000.0d0+thl  ![MeV]

       cs_tail=((k*z(IS))/(anuc_cry2(IS)*betar**2))*
     + ((0.5*((1.0d0/Tt)-(1.0d0/Tmax)))-
     + (log(Tmax/Tt)*(betar**2)/(2.0d0*Tmax))+
     + ((Tmax-Tt)/(4.0d0*(gammar**2)*(mp**2))))

       prob_tail=cs_tail*rho(IS)*DZ*100.0d0;

       ranc=dble(rndm4())

       if(ranc.lt.prob_tail)then
         EnLo=((k*z(IS))/(anuc_cry2(IS)*betar**2))*
     +   (0.5*log((2.0d0*me*bgr*bgr*Tmax)/(Ime(IS)*Ime(IS)))
     +   -betar**2.0-log(plen/Ime(IS))-log(bgr)+0.5+
     +   (TMax**2)/(8.0d0*(gammar**2)*(mp**2)));

         EnLo=EnLo*rho(IS)*0.1 ![GeV/m]

       else 
         EnLo=EnLo/DZ  ![GeV/m]
       endif
     
c      write(*,*)cs_tail,prob_tail,ranc,EnLo*DZ

      RETURN
      END



C--------------------------------------------

C     
C-----------SimCrys::move_am() in simcrys.cc
C
C The two routines are NOT the same!!!!!!!
C
C  Commented by Jianfeng Zhang @ LAL, 29/04/2014

C.**************************************************************************
C     subroutine for the movement in the amorphous 
C.**************************************************************************
      SUBROUTINE MOVE_AM_(IS,NAM,DZ,DEI,DLY,DLr, XP,YP,PC)
C. Moving in amorphous substance...........................
      IMPLICIT none
      integer IS,NAM
      double precision DZ,DEI,DLY,DLr, XP,YP,PC
      double precision DLAI(4),SAI(4),DES(4)
      double precision DLRI(4),DLYI(4),AI(4)
      double precision AM(30),QP(30),NPAI
      double precision Dc(4),eUm(4)
      double precision DYA,W_p
c      REAL*4 RNDM4
c         REAL*4      RAN_GAUSS
      double precision RNDM4
      double precision      RAN_GAUSS
      CHARACTER*50 PROC              !string that contains the physical process 
      COMMON /ALAST/DLAI,SAI
      COMMON/CRYS/ DLRI,DLYI,AI,DES
      common /Proc2/PROC


!------- adding variables --------


      double precision cprob_cry(0:5,1:4)
      double precision cs(0:5,1:4)
      double precision csref_cry(0:5,1:4)
      double precision freep(4)
      double precision anuc_cry(4)
      double precision collnt_cry(4)
      double precision bn(4)
      double precision bnref_cry(4)

      double precision freeco_cry,ppel,ppsd,pptot,pptref_cry,pptco_cry
      double precision pperef_cry,sdcoe_cry,pref_cry,ppeco_cry

      double precision ecmsq,xln15s,bpp,xm2,bsd,t,teta,va,vb,va2,vb2
      double precision tx,tz,r2,zlm,f

      integer i,ichoix
      double precision aran

      common/scat_cry/cprob_cry,csref_cry,collnt_cry,bnref_cry,anuc_cry
      common/scat_cry/pptref_cry,pperef_cry,sdcoe_cry,pref_cry
      common/scat_cry/pptco_cry,ppeco_cry,freeco_cry

      double precision tlcut_cry,hcut_cry(4)
      real cgen_cry(200,4),tlow,thigh,ruth_cry
      external ruth_cry

      common/ruth_scat_cry/tlcut_cry,hcut_cry
      common/ruth_scat_cry/cgen_cry,mcurr_cry

      integer length_cry,mcurr_cry
      real xran_cry(1)

!-------daniele--------------
! adding new variables to study the energy loss when the routine is called
!---------------------------

      double precision PC_in_dan     !daniele     
      integer PROC_dan    !daniele
      double precision xp_in,yp_in,kxmcs,kymcs
       double precision  ran_x, ran_y

      PC_in_dan=PC                   !daniele

      xp_in=XP
      yp_in=YP


!---------------daniele------------
! NEW TREATMENT OF SCATTERING ROUTINE BASED ON STANDARD SIXTRACK ROUTINE
!----------------------------------


!------- useful calculations for cross-section and event topology calculation --------------

      ecmsq = 2 * 0.93828d0 * PC
      xln15s=log(0.15*ecmsq)
! pp(pn) data
      pptot = pptref_cry *(PC / pref_cry)** pptco_cry
      ppel = pperef_cry *(PC / pref_cry)** ppeco_cry
      ppsd = sdcoe_cry * log(0.15d0 * ecmsq)
      bpp = 8.5d0 + 1.086d0 * log(sqrt(ecmsq))

!------ distribution for Ruth. scatt.---------

      tlow=tlcut_cry
      mcurr_cry=IS
      thigh=hcut_cry(IS)
!      write(*,*)tlow,thigh
      call funlxp(ruth_cry,cgen_cry(1,IS),tlow,thigh)



!---------- cross-section calculation -----------

!
! freep: number of nucleons involved in single scattering
        freep(IS) = freeco_cry * anuc_cry(IS)**(1d0/3d0)
! compute pp and pn el+single diff contributions to cross-section
! (both added : quasi-elastic or qel later)
        cs(3,IS) = freep(IS) * ppel
        cs(4,IS) = freep(IS) * ppsd
!
! correct TOT-CSec for energy dependence of qel
! TOT CS is here without a Coulomb contribution
        cs(0,IS) = csref_cry(0,IS) + freep(IS) * (pptot - pptref_cry)
        bn(IS) = bnref_cry(IS) * cs(0,IS) / csref_cry(0,IS)               
! also correct inel-CS
        cs(1,IS) = csref_cry(1,IS) * cs(0,IS) / csref_cry(0,IS)
!
! Nuclear Elastic is TOT-inel-qel ( see definition in RPP)
        cs(2,IS) = cs(0,IS) - cs(1,IS) - cs(3,IS) - cs(4,IS)
        cs(5,IS) = csref_cry(5,IS)
! Now add Coulomb
        cs(0,IS) = cs(0,IS) + cs(5,IS)
! Interaction length in meter
!        xintl(ma) = 0.01d0*anuc(ma)/(fnavo * rho(ma)*cs(0,ma)*1d-24)  !don't need at the moment, take it from pdg


! Calculate cumulative probability

        do i=1,4
          cprob_cry(i,IS)=cprob_cry(i-1,IS)+cs(i,IS)/cs(0,IS)
        end do
C------------------------------

C--------------------------------------------

C     
C-----------SimCrys::cross() in simcrys.cc
C   ----The physics are the same.
C  Commented by Jianfeng Zhang @ LAL, 29/04/2014

!--------- Multiple Coulomb Scattering ---------

     
c      write(*,*) "In Move_AM(): "


      xp=xp*1000
      yp=yp*1000
c      write(*,*)'xp initial:', xp, 'yp initial', yp
C. DEI - dE/dx stoping energy
      PC    = PC - DEI*DZ    ! energy lost because of ionization process[GeV]

C. DYA - rms of coloumb scattering
      DYA = (13.6/PC)*SQRT(DZ/DLr)             !MCS (mrad)
c      write(*,*)'dya= ',dya
      
      ran_x = RAN_GAUSS(1.)
c      write(*,*) "ran_x = ", ran_x
      
      ran_y = RAN_GAUSS(1.)
c      write(*,*) "ran_y = ", ran_y
      
      kxmcs = DYA*ran_x
      kymcs = DYA*ran_y
      
c      kxmcs = DYA*RAN_GAUSS(1.)
c     kymcs = DYA*RAN_GAUSS(1.)

      XP = xp+kxmcs
      yp = yp+kymcs
      
c       write(*,*) "ran_x = ", ran_x, "ran_y = ", ran_y
c      write(*,*) "kxmcs = ", kxmcs, "kymcs = ", kymcs
c      write(*,*)'xp + kxmcs:', XP, 'yp + kxmcs', YP
      
cc     XP    = XP+DYA*RAN_GAUSS(1.)
cc      YP    = YP+DYA*RAN_GAUSS(1.)

      if(NAM .eq. 0) return                    !turn on/off nuclear interactions


!--------- Can nuclear interaction happen? -----


      zlm=-collnt_cry(IS)*log(dble(rndm4()))

c      zlm=0.0  

      if(zlm.lt.DZ) then

!--------- Choose nuclear interaction --------


      aran=dble(rndm4())
      i=1
  10  if ( aran.gt.cprob_cry(i,IS) ) then
          i=i+1
          goto 10
      endif
      ichoix=i


!-------- Do the interaction ---------- 

c      ichoix=2

      if (ichoix.eq.1) then

        PROC = 'absorbed'            !deep inelastic, impinging p disappeared

      endif

      if (ichoix.eq.2) then          ! p-n elastic
        PROC = 'pne'
        t = -log(dble(rndm4()))/bn(IS)
      endif

      if ( ichoix .eq. 3 ) then   !p-p elastic
        PROC='ppe'
        t = -log(dble(rndm4()))/bpp
      endif

      if ( ichoix .eq. 4 ) then   !single diffractive
        PROC='diff'
        xm2 = exp( dble(rndm4()) * xln15s )
        PC = PC  *(1.d0 - xm2/ecmsq)
          if ( xm2 .lt. 2.d0 ) then
             bsd = 2.d0 * bpp
           elseif (( xm2 .ge. 2.d0 ).and. ( xm2 .le. 5.d0 )) then
                bsd = (106.d0-17.d0*xm2) *  bpp / 26.d0
           elseif ( xm2 .gt. 5.d0 ) then
                bsd = 7.d0 * bpp / 12.d0
          endif
        t = -log(dble(rndm4()))/bsd
      endif

      if ( ichoix .eq. 5 ) then
        PROC='ruth'
           length_cry=1
           call funlux( cgen_cry(1,IS) ,xran_cry,length_cry)
           t=xran_cry(1)
      endif

c      write(*,*) "ichoix = ", ichoix
c       write(*,*)'xp final:', xp, 'yp final', yp
       
!---------- calculate the related kick -----------


      if ( ichoix .eq. 4) then      
        teta = sqrt(t)/PC_in_dan                !DIFF has changed PC!!!
      else
        teta = sqrt(t)/PC
      endif


c 100  va  =2d0*rndm4()-1d0  
c      vb = dble(rndm4())
c      va2 = va*va
c      vb2 = vb*vb
c      r2 = va2 + vb2
c      if ( r2.gt.1.d0) go to 100
c      tx = teta * (2.d0*va*vb) / r2
c      tz = teta * (va2 - vb2) / r2

cc 100  va  =2d0*rndm4()-1d0  
cc      vb  =2d0*rndm4()-1d0  
cc      va2 = va*va
cc      vb2 = vb*vb
cc      r2 = va2 + vb2
cc      if ( r2.gt.1.d0) go to 100
cc      f = SQRT(-2d0*LOG(r2)/r2)
cc      tx = teta*f*va
cc      tz = teta*f*vb


      tx= teta * RAN_GAUSS(1.)
      tz= teta * RAN_GAUSS(1.)

      tx = tx * 1000
      tz = tz * 1000

!---------- change p angle --------


c      write(*,*) "tx = ", tx, " tz = ", tz
      
      XP = XP + tx
      YP = YP + tz

      end if                !close the if(zlm.lt.DZ)

      xp=xp/1000
      yp=yp/1000

c      write(*,*)'xp final:', xp, 'yp final', yp
!-----------------------------------------------
! print out the energy loss and process experienced
!-------------------

               if (PROC(1:2).eq.'AM')then
                 PROC_dan=1
               elseif (PROC(1:2).eq.'VR') then
                 PROC_dan=2
               elseif (PROC(1:2).eq.'CH')then
                 PROC_dan=3
               elseif (PROC(1:2).eq.'VC') then
                 PROC_dan=4
               elseif (PROC(1:3).eq.'out')then
                 PROC_dan=-1
               elseif (PROC(1:8).eq.'absorbed') then
                 PROC_dan=5
               elseif (PROC(1:2).eq.'DC')then
                 PROC_dan=6
               elseif (PROC(1:3).eq.'pne')then                
                 PROC_dan=7
               elseif (PROC(1:3).eq.'ppe')then                
                 PROC_dan=8
               elseif (PROC(1:4).eq.'diff')then  
                 PROC_dan=9
               elseif (PROC(1:4).eq.'ruth')then  
                 PROC_dan=10

               endif

c      write(889,*) PC_in_dan, PC, PROC_dan, tx,tz,
c     & xp-xp_in-(kxmcs/1000), yp-yp_in-(kymcs/1000) 


      RETURN
      END


!--------- Multiple Coulomb Scattering ---------

cc      xp=xp*1000
cc      yp=yp*1000
c      write(*,*)'xp initial:', xp, 'yp initial', yp
C. DEI - dE/dx stoping energy
cc      PC    = PC - DEI*DZ    ! energy lost beacause of ionization process[GeV]

C. DYA - rms of coloumb scattering
cc      DYA = (13.6/PC)*SQRT(DZ/DLr)             !MCS (mrad)
c      write(*,*)'dya=',dya

cc      kxmcs = DYA*RAN_GAUSS(1.)
cc      kymcs = DYA*RAN_GAUSS(1.)

cc      XP = xp+kxmcs
cc      yp = yp+kymcs
 
c      XP    = XP+DYA*RAN_GAUSS(1.)
c      YP    = YP+DYA*RAN_GAUSS(1.)

cc      xp = xp/1000
cc      yp = yp/1000 

!--------END DANIELE------------------------------------


C.**************************************************************************
C     DANIELE subroutine for check if a nuclear interaction happen while in channeling 
C.**************************************************************************
      SUBROUTINE MOVE_CH_(IS,NAM,DZ,X,XP,YP,PC,R,Rc)

      IMPLICIT none
      integer IS,NAM
      double precision DZ,X,XP,YP,PC,R,Rc
      double precision DLAI(4),SAI(4),DES(4)
      double precision DLRI(4),DLYI(4),AI(4)
      double precision AM(30),QP(30),NPAI
      double precision Dc(4),eUm(4)
      double precision DYA,W_p
c      REAL*4 RNDM4
c         REAL*4      RAN_GAUSS
      double precision RNDM4
      double precision   RAN_GAUSS
      CHARACTER*50 PROC              !string that contains the physical process 
      COMMON /ALAST/DLAI,SAI
      COMMON/CRYS/ DLRI,DLYI,AI,DES
      common /Proc2/PROC
      COMMON/eUc/eUm

!------- adding variables --------


      double precision cprob_cry(0:5,1:4)
      double precision cs(0:5,1:4)
      double precision csref_cry(0:5,1:4)
      double precision freep(4)
      double precision anuc_cry(4)
      double precision collnt_cry(4)
      double precision bn(4)
      double precision bnref_cry(4)

      double precision freeco_cry,ppel,ppsd,pptot,pptref_cry,pptco_cry
      double precision pperef_cry,sdcoe_cry,pref_cry,ppeco_cry

      double precision ecmsq,xln15s,bpp,xm2,bsd,t,teta,va,vb,va2,vb2
      double precision tx,tz,r2,zlm,f

      integer i,ichoix
      double precision aran

      common/scat_cry/cprob_cry,csref_cry,collnt_cry,bnref_cry,anuc_cry
      common/scat_cry/pptref_cry,pperef_cry,sdcoe_cry,pref_cry
      common/scat_cry/pptco_cry,ppeco_cry,freeco_cry

      double precision tlcut_cry,hcut_cry(4)
      real cgen_cry(200,4),tlow,thigh,ruth_cry
      external ruth_cry

      common/ruth_scat_cry/tlcut_cry,hcut_cry
      common/ruth_scat_cry/cgen_cry,mcurr_cry

      integer length_cry,mcurr_cry
      real xran_cry(1)



!-------daniele--------------
! adding new variables for calculation of average density seen
!---------------------------

      integer Np
      double precision aTF,dP,N_am,rho_min,rho_Max,u1,avrrho
      double precision x_i,Ueff,pv,Et,Ec,x_min,x_Max,nuc_cl_l
      double precision xminU,Umin

      common/dech/aTF,dP,u1

      double precision rho(4),z(4),Ime(4) 
      double precision k,re,me,mp
      double precision anuc_cry2(4)
      real emr_cry(4)

      common/ion/rho,z,Ime,k,re,me,mp,anuc_cry2,emr_cry

      double precision csref_tot_rsc,csref_inel_rsc

!-------daniele--------------
! adding new variables to study the energy loss when the routine is called
!---------------------------


      double precision PC_in_dan     !daniele     
      integer PROC_dan    !daniele
      double precision xp_in,yp_in,kxmcs,kymcs


      PC_in_dan=PC                   !daniele

      xp_in=XP
      yp_in=YP


!---------------daniele------------
! NEW TREATMENT OF SCATTERING ROUTINE BASED ON STANDARD SIXTRACK ROUTINE
!----------------------------------


!------- useful calculations for cross-section and event topology calculation --------------

      ecmsq = 2 * 0.93828d0 * PC
      xln15s=log(0.15*ecmsq)
! pp(pn) data
      pptot = pptref_cry *(PC / pref_cry)** pptco_cry
      ppel = pperef_cry *(PC / pref_cry)** ppeco_cry
      ppsd = sdcoe_cry * log(0.15d0 * ecmsq)
      bpp = 8.5d0 + 1.086d0 * log(sqrt(ecmsq))

!------ distribution for Ruth. scatt.---------

      tlow=tlcut_cry
      mcurr_cry=IS
      thigh=hcut_cry(IS)
!      write(*,*)tlow,thigh
      call funlxp(ruth_cry,cgen_cry(1,IS),tlow,thigh)

!---------- rescale the total and inelastic cross-section accordigly to the average density seen

      x_i=X

      Np=INT(x_i/dP)       !calculate in which cristalline plane the particle enters
      x_i=x_i-Np*dP        !rescale the incoming x at the left crystalline plane
      x_i=x_i-(dP/2.d0)    !rescale the incoming x in the middle of crystalline planes

      pv=PC*1.d9*PC*1.d9/sqrt(PC*1.d9*PC*1.d9+93828.d6*93828.d6)        !calculate pv=P/E

      Ueff=eUm(IS)*(2.d0*x_i/dP)*(2.d0*x_i/dP)+pv*x_i/R   !calculate effective potential

      Et=pv*XP*XP/2.+Ueff                                !calculate transverse energy

      Ec=eUm(IS)*(1.d0-Rc/R)*(1.d0-Rc/R)                 !calculate critical energy in bent crystals

!---- to avoid negative Et

      xminU=-dP*dP*PC*1e9/(8.d0*eUm(IS)*R)
      Umin=abs(eUm(IS)*(2.d0*xminU/dP)*(2.d0*xminU/dP)+pv*xminU/R)
      Et=Et+Umin
      Ec=Ec+Umin

!-----

c      write(*,*)xminU,Umin,Et,Ec,pv,XP,Ueff

      x_min=-(dP/2.d0)*Rc/R-(dP/2.d0)*sqrt(Et/Ec);          !calculate min e max of the trajectory between crystalline planes
      x_Max=-(dP/2.d0)*Rc/R+(dP/2.d0)*sqrt(Et/Ec);

      x_min=x_min-dP/2.d0;                                    !change ref. frame and go back with 0 on the crystalline plane on the left 
      x_Max=x_Max-dP/2.d0;

      N_am=rho(IS)*6.022d23*1.d6/anuc_cry2(IS)           !calculate the "normal density" in m^-3
     
      rho_Max=N_am*dP/2.d0*(erf(x_Max/sqrt(2.d0*u1*u1))        !calculate atomic density at min and max of the trajectory oscillation
     + -erf((dP-x_Max)/sqrt(2*u1*u1)))

      rho_min=N_am*dP/2.d0*(erf(x_min/sqrt(2.d0*u1*u1))
     + -erf((dP-x_min)/sqrt(2*u1*u1)));

      avrrho=(rho_Max-rho_min)/(x_Max-x_min)                        !"zero-approximation" of average nuclear density seen along the trajectory

      avrrho=2.d0*avrrho/N_am

      csref_tot_rsc=csref_cry(0,IS)*avrrho        !rescaled total ref cs
      csref_inel_rsc=csref_cry(1,IS)*avrrho        !rescaled inelastic ref cs

c      write(889,*) x_i,pv,Ueff,Et,Ec,N_am,avrrho,
c     + csref_tot_rsc,csref_inel_rsc

!---------- cross-section calculation -----------

!
! freep: number of nucleons involved in single scattering
        freep(IS) = freeco_cry * anuc_cry(IS)**(1d0/3d0)
! compute pp and pn el+single diff contributions to cross-section
! (both added : quasi-elastic or qel later)
        cs(3,IS) = freep(IS) * ppel
        cs(4,IS) = freep(IS) * ppsd
!
! correct TOT-CSec for energy dependence of qel
! TOT CS is here without a Coulomb contribution
        cs(0,IS) = csref_tot_rsc + freep(IS) * (pptot - pptref_cry)
        bn(IS) = bnref_cry(IS) * cs(0,IS) / csref_tot_rsc               
! also correct inel-CS
        cs(1,IS) = csref_inel_rsc * cs(0,IS) / csref_tot_rsc
!
! Nuclear Elastic is TOT-inel-qel ( see definition in RPP)
        cs(2,IS) = cs(0,IS) - cs(1,IS) - cs(3,IS) - cs(4,IS)
        cs(5,IS) = csref_cry(5,IS)
! Now add Coulomb
        cs(0,IS) = cs(0,IS) + cs(5,IS)
! Interaction length in meter
!        xintl(ma) = 0.01d0*anuc(ma)/(fnavo * rho(ma)*cs(0,ma)*1d-24)  !don't need at the moment, take it from pdg


! Calculate cumulative probability

        do i=1,4
          cprob_cry(i,IS)=cprob_cry(i-1,IS)+cs(i,IS)/cs(0,IS)
        end do


!--------- Multiple Coulomb Scattering ---------

      xp=xp*1000
      yp=yp*1000

!-------- not needed, energy loss by ionization taken into account in the main body


c      write(*,*)'xp initial:', xp, 'yp initial', yp
C. DEI - dE/dx stoping energy
!      PC    = PC - DEI*DZ    ! energy lost beacause of ionization process[GeV]

C. DYA - rms of coloumb scattering
!      DYA = (13.6/PC)*SQRT(DZ/DLr)             !MCS (mrad)
c      write(*,*)'dya=',dya

!      kxmcs = DYA*RAN_GAUSS(1.)
!      kymcs = DYA*RAN_GAUSS(1.)

!      XP = xp+kxmcs
!      yp = yp+kymcs
 
cc     XP    = XP+DYA*RAN_GAUSS(1.)
cc      YP    = YP+DYA*RAN_GAUSS(1.)

      if(NAM .eq. 0) return                    !turn on/off nuclear interactions


!--------- Can nuclear interaction happen? -----


      nuc_cl_l=collnt_cry(IS)/avrrho        !rescaled nuclear collision length

      zlm=-nuc_cl_l*log(dble(rndm4()))

c      zlm=0.0  

      write(889,*) x_i,pv,Ueff,Et,Ec,N_am,avrrho,
     + csref_tot_rsc,csref_inel_rsc,nuc_cl_l

      if(zlm.lt.DZ) then

!--------- Choose nuclear interaction --------


      aran=dble(rndm4())
      i=1
  10  if ( aran.gt.cprob_cry(i,IS) ) then
          i=i+1
          goto 10
      endif
      ichoix=i


!-------- Do the interaction ---------- 

c      ichoix=3

      if (ichoix.eq.1) then

        PROC = 'ch_absorbed'            !deep inelastic, impinging p disappeared

      endif

      if (ichoix.eq.2) then          ! p-n elastic
        PROC = 'ch_pne'
        t = -log(dble(rndm4()))/bn(IS)
      endif

      if ( ichoix .eq. 3 ) then   !p-p elastic
        PROC='ch_ppe'
        t = -log(dble(rndm4()))/bpp
      endif

      if ( ichoix .eq. 4 ) then   !single diffractive
        PROC='ch_diff'
        xm2 = exp( dble(rndm4()) * xln15s )
        PC = PC  *(1.d0 - xm2/ecmsq)
          if ( xm2 .lt. 2.d0 ) then
             bsd = 2.d0 * bpp
           elseif (( xm2 .ge. 2.d0 ).and. ( xm2 .le. 5.d0 )) then
                bsd = (106.d0-17.d0*xm2) *  bpp / 26.d0
           elseif ( xm2 .gt. 5.d0 ) then
                bsd = 7.d0 * bpp / 12.d0
          endif
        t = -log(dble(rndm4()))/bsd
      endif

      if ( ichoix .eq. 5 ) then
        PROC='ch_ruth'
           length_cry=1
           call funlux( cgen_cry(1,IS) ,xran_cry,length_cry)
           t=xran_cry(1)
      endif

!---------- calculate the related kick -----------


      if ( ichoix .eq. 4) then      
        teta = sqrt(t)/PC_in_dan                !DIFF has changed PC!!!
      else
        teta = sqrt(t)/PC
      endif


c 100  va  =2d0*rndm4()-1d0  
c      vb = dble(rndm4())
c      va2 = va*va
c      vb2 = vb*vb
c      r2 = va2 + vb2
c      if ( r2.gt.1.d0) go to 100
c      tx = teta * (2.d0*va*vb) / r2
c      tz = teta * (va2 - vb2) / r2

cc 100  va  =2d0*rndm4()-1d0  
cc      vb  =2d0*rndm4()-1d0  
cc      va2 = va*va
cc      vb2 = vb*vb
cc      r2 = va2 + vb2
cc      if ( r2.gt.1.d0) go to 100
cc      f = SQRT(-2d0*LOG(r2)/r2)
cc      tx = teta*f*va
cc      tz = teta*f*vb


      tx= teta * RAN_GAUSS(1.)
      tz= teta * RAN_GAUSS(1.)

      tx = tx * 1000
      tz = tz * 1000

!---------- change p angle --------

      XP = XP + tx
      YP = YP + tz

      end if                !close the if(zlm.lt.DZ)

      xp=xp/1000
      yp=yp/1000


!-----------------------------------------------
! print out the energy loss and process experienced
!-------------------

               if (PROC(1:2).eq.'AM')then
                 PROC_dan=1
               elseif (PROC(1:2).eq.'VR') then
                 PROC_dan=2
               elseif (PROC(1:2).eq.'CH')then
                 PROC_dan=3
               elseif (PROC(1:2).eq.'VC') then
                 PROC_dan=4
               elseif (PROC(1:3).eq.'out')then
                 PROC_dan=-1
               elseif (PROC(1:11).eq.'ch_absorbed') then
                 PROC_dan=15
               elseif (PROC(1:2).eq.'DC')then
                 PROC_dan=6
               elseif (PROC(1:6).eq.'ch_pne')then                
                 PROC_dan=17
               elseif (PROC(1:6).eq.'ch_ppe')then                
                 PROC_dan=18
               elseif (PROC(1:7).eq.'ch_diff')then  
                 PROC_dan=19
               elseif (PROC(1:7).eq.'ch_ruth')then  
                 PROC_dan=20

               endif

c      write(889,*) PC_in_dan, PC, PROC_dan, tx,tz,
c     & xp-xp_in-(kxmcs/1000), yp-yp_in-(kymcs/1000) 

!-------- Block Data ----------

      RETURN
      END
C      
      BLOCK DATA
      implicit none
      double precision DLAI(4),SAI(4)
      double precision DLRI(4),DLYI(4),AI(4),DES(4)
      double precision eUm(4)
      COMMON /ALAST/DLAI,SAI
      COMMON/CRYS/ DLRI,DLYI,AI,DES
      COMMON/eUc/  eUm
C-----4 substances: Si(110),W(110),C,Ge----------------------------
      DATA DLRI/0.0937,.0035,0.188,.023/    ! radiation  length(m), updated from pdg for Si
     +    ,DLYI/.455, .096, .400, .162/      ! nuclear length(m)
     +    ,AI /0.96E-7, 0.56E-7, 0.63E-7, 1.E-7/  !Si110 1/2 interplan. dist. mm
     +    ,DES/0.56,  3.0,  0.6, 1./         ! energy deposition in subst(GeV/m)
     +    ,DLAI/1.6,  0.57, 2.2, 1.0/        ! elastic length(m)
     +    ,SAI /42.,  140.,  42., 50./       ! elastic scat. r.m.s(mr)
     +    ,eUm/21.34,  21.,   21.,   21./    ! only for Si(110) potent. [eV]


!------------- daniele, more data needed---------

      double precision cprob_cry(0:5,1:4)
!      double precision cs(5,4)
      double precision csref_cry(0:5,1:4) 
      double precision anuc_cry(4)
      double precision collnt_cry(4)
      double precision bnref_cry(4)
      double precision pptref_cry,pperef_cry,sdcoe_cry,pref_cry
      double precision pptco_cry,ppeco_cry,freeco_cry


      common/scat_cry/cprob_cry,csref_cry,collnt_cry,bnref_cry,anuc_cry
      common/scat_cry/pptref_cry,pperef_cry,sdcoe_cry,pref_cry
      common/scat_cry/pptco_cry,ppeco_cry,freeco_cry


      integer i

      data (cprob_cry(0,i),i=1,4)/4*0.0d0/
      data (cprob_cry(5,i),i=1,4)/4*1.0d0/

! pp cross-sections and parameters for energy dependence
      data pptref_cry,pperef_cry/0.04d0,0.007d0/
      data sdcoe_cry,pref_cry/0.00068d0,450.0d0/
      data pptco_cry,ppeco_cry,freeco_cry/0.05788d0,0.04792d0,1.618d0/

! Atomic mass [g/mole] from pdg

      data (anuc_cry(i),i=1,4)/28.08d0,0.0d0,0.0d0,0.0d0/     !implemented only Si

! Total and nuclear cross-sections [barn], implemeted only Si
      data csref_cry(0,1),csref_cry(1,1)/0.664d0, 0.430d0/  !from pdg
c      data csref_cry(0,1),csref_cry(1,1)/0.762d0, 0.504d0/  !with glauber's approx (NIMB 268 (2010) 2655-2659)
      data csref_cry(0,2),csref_cry(1,2)/0.0d0, 0.0d0/
      data csref_cry(0,3),csref_cry(1,3)/0.0d0, 0.0d0/
      data csref_cry(0,4),csref_cry(1,4)/0.0d0, 0.0d0/

      data csref_cry(5,1)/0.039d-2/
      data csref_cry(5,2)/0.0d0/
      data csref_cry(5,3)/0.0d0/
      data csref_cry(5,4)/0.0d0/
     


! Nuclear Collision length [m] from pdg (only for Si for the moment)

      data (collnt_cry(i),i=1,4)/0.3016d0,0.0d0,0.0d0,0.0d0/

! Nuclear elastic slope from Schiz et al.,PRD 21(3010)1980

      data (bnref_cry(i),i=1,4)/123.2d0,0.0d0,0.0d0,0.0d0/      !(only for Si for the moment)

! For calculation of dE/dX due to ionization

      double precision rho(4),z(4),Ime(4),anuc_cry2(4) !Daniele: material parameters for dE/dX calculation  
      double precision k,re,me,mp !Daniele: parameters for dE/dX calculation (const,electron radius,el. mass, prot.mass)

      real emr_cry(4) !nuclear radius for Ruth scatt.

      common/ion/rho,z,Ime,k,re,me,mp,anuc_cry2,emr_cry

      data (rho(i),i=1,4)/2.33d0,0.0d0,0.0d0,0.0d0/  !material density [g/cm^3] 
      data (z(i),i=1,4)/14.0d0,0.0d0,0.0d0,0.0d0/    !atomic number
      data (Ime(i),i=1,4)/173.0d-6,0.0d0,0.0d0,0.0d0/!mean exitation energy [MeV]
      data (anuc_cry2(i),i=1,4)/28.08d0,0.0d0,0.0d0,0.0d0/     !implemented only Si
      data (emr_cry(i),i=1,4)/0.306d0,0.0d0,0.0d0,0.0d0/      !nuclear radius take from R_Be*(A_Si/A_Be)^1/3, where R_Be=0.302


      data k/0.307075/ !constant in front bethe-bloch [MeV g^-1 cm^2]
      data re/2.818d-15/  !electron radius [m]
      data me/0.510998910/ !electron mass [MeV/c^2]
      data mp/938.272013/ !proton mass [MeV/c^2]

! For calculation of dechanneling length

      double precision aTF,dP,u1

      common/dech/aTF,dP,u1

      data aTF/0.194d-10/ !screening function [m]
      data dP/1.92d-10/   !distance between planes (110) [m]
      data u1/0.075d-10/  !thermal vibrations amplitude

      double precision tlcut_cry,hcut_cry(4)   !param. for Ruth scatt.
      real cgen_cry(200,4)
      integer mcurr_cry

      common/ruth_scat_cry/tlcut_cry,hcut_cry
      common/ruth_scat_cry/cgen_cry,mcurr_cry

      data tlcut_cry/0.0009982d0/
      data (hcut_cry(i),i=1,4)/0.02d0,0.0d0,0.0d0,0.0d0/


      END

!------------------daniele: definition of rutherford scattering formula--------!

      function ruth_cry(t_cry)
      implicit none
      integer nmat_cry,mcurr_cry
      parameter(nmat_cry=4)
!      double precision z(4),emr_cry(4),tlcut_cry,hcut_cry(4)
      double precision tlcut_cry,hcut_cry(4)

      double precision rho(4),z(4),Ime(4),anuc_cry2(4) !Daniele: material parameters for dE/dX calculation  
      double precision k,re,me,mp !Daniele: parameters for dE/dX calculation (const,electron radius,el. mass, prot.mass)

      real emr_cry(4)

      real cgen_cry(200,4)
  
      common/ion/rho,z,Ime,k,re,me,mp,anuc_cry2,emr_cry

!      common/ion/z,emr_cry
      common/ruth_scat_cry/tlcut_cry,hcut_cry
      common/ruth_scat_cry/cgen_cry,mcurr_cry

      real ruth_cry,t_cry
      double precision cnorm,cnform
      parameter(cnorm=2.607d-4,cnform=0.8561d3)
!      parameter(cnorm=2.607d-5,cnform=0.8561d3) !daniele: corrected constant
!c      write(6,'('' t,exp'',2e15.8)')t,t*cnform*EMr(mcurr)**2
!      write(*,*)mcurr_cry,emr_cry(mcurr_cry),z(mcurr_cry),t_cry      

       ruth_cry=cnorm*exp(-t_cry*cnform*emr_cry(mcurr_cry)**2)*
     + (z(mcurr_cry)/t_cry)**2

      end


!------------------------------past treatment commented (c always comment, cc old line)----------------------------------------------------------------------------------



cc      xp=xp*1000
cc      yp=yp*1000
c      write(*,*)'xp initial:', xp, 'yp initial', yp
C. DEI - dE/dx stoping energy
cc      PC    = PC - DEI*DZ    ! energy lost beacause of ionization process[GeV]
C. Coulomb scattering
C. DYA - rms of coloumb scattering
cc      DYA = (14.0/PC)*SQRT(DZ/DLr)             !MCS (mrad)
c      write(*,*)'dya=',dya
cc      XP    = XP+DYA*RAN_GAUSS(1.)
cc      YP    = YP+DYA*RAN_GAUSS(1.)

cc      if(NAM .eq. 0) return
C.  Elastic scattering
cc      IF (rndm4() .LE. DZ/DLAI(IS)) THEN
cc        PROC = 'mcs'
c         write(*,*)'case 1'
c        XP    = XP+SAI(IS)*RAN_GAUSS(1.)/PC 
c        YP    = YP+SAI(IS)*RAN_GAUSS(1.)/PC
cc        xp    = xp+196.*RAN_GAUSS(1.)/PC ! angle elast. scattering in R plane
cc        yp    = yp+196.*RAN_GAUSS(1.)/PC
cc      ENDIF
C.  Diffraction interaction
cc      IF (rndm4() .LE. DZ/(DLY*6.143)) THEN
cc        PROC = 'diff'
c         write(*,*)'case 2'

!######################################################
! daniele: comment old treatement to implement the same as standard SixTrack
!######################################################

c        XP    = XP+ 257.0*RAN_GAUSS(1.)/PC ! angle elast. scattering in R plane
c        YP    = YP+ 257.0*RAN_GAUSS(1.)/PC
c        W_p = rndm4()
c        PC = PC -0.5*(0.3*PC)**W_p             ! m0*c = 1 GeV/c for particle

!############## end comment -> "new" treatment of diffractive interactions #########

c         ecmsq = 2 * 0.93828d0 * PC
c         xln15s=log(0.15*ecmsq) 
c         bpp = 8.5d0 + 1.086d0 * log(sqrt(ecmsq))
c         xm2 = exp( dble(rndm4()) * xln15s )
c         PC = PC  *(1.d0 - xm2/ecmsq)

c         if ( xm2 .lt. 2.d0 ) then
c              bsd = 2.d0 * bpp
c            elseif (( xm2 .ge. 2.d0 ).and. ( xm2 .le. 5.d0 )) then
c              bsd = (106.d0-17.d0*xm2) *  bpp / 26.d0
c            elseif ( xm2 .gt. 5.d0 ) then
c              bsd = 7.d0 * bpp / 12.d0
c         endif
 
c         t = -log(dble(rndm4()))/bsd
c         teta = sqrt(t)/PC
c      10 va  =2d0*rndm4()-1d0  
c         vb = dble(rndm4())
c         va2 = va*va
c         vb2 = vb*vb
c         r2 = va2 + vb2
c         if ( r2.gt.1.d0) go to 10
c         tx = teta * (2.d0*va*vb) / r2
c         tz = teta * (va2 - vb2) / r2

c         XP = XP + tx
c         YP = YP + tz

!#################### end of "new" treatment ###############

cc      ENDIF
C.  Inelastic interaction
cc      IF (rndm4() .LE. DZ/DLY) THEN
c        PC = 0.                                         !daniele: needed for debugged energy loss in the crystal, otherwise SixTrack get stuck if PC=0 (anyway the particle is "forgot" from now)
cc        PROC = 'absorbed'
cc      ENDIF
c      write(*,*)'xp final:', xp, 'yp final', yp
cc      xp=xp/1000
cc      yp=yp/1000


!---------------DANIELE--------------------------------
! print out the energy loss and process experienced
!-------------------

cc               if (PROC(1:2).eq.'AM')then
cc                 PROC_dan=1
cc               elseif (PROC(1:2).eq.'VR') then
cc                 PROC_dan=2
cc               elseif (PROC(1:2).eq.'CH')then
cc                 PROC_dan=3
cc               elseif (PROC(1:2).eq.'VC') then
cc                 PROC_dan=3
cc               elseif (PROC(1:3).eq.'out')then
cc                 PROC_dan=-1
cc              elseif (PROC(1:8).eq.'absorbed') then
cc                 PROC_dan=5
cc               elseif (PROC(1:2).eq.'DC')then
cc                 PROC_dan=6
cc               elseif (PROC(1:3).eq.'mcs')then                
cc                 PROC_dan=7
cc               elseif (PROC(1:4).eq.'diff')then  
cc                 PROC_dan=8
cc               endif

cc      write(889,*) PC_in_dan, PC, PROC_dan  

!--------END DANIELE------------------------------------

cc      RETURN
cc      END
C      
cc      BLOCK DATA
cc      implicit none
cc      double precision DLAI(4),SAI(4)
cc      double precision DLRI(4),DLYI(4),AI(4),DES(4)
cc      double precision eUm(4)
cc      COMMON /ALAST/DLAI,SAI
cc      COMMON/CRYS/ DLRI,DLYI,AI,DES 
cc      COMMON/eUc/  eUm
C-----4 substances: Si(110),W(110),C,Ge----------------------------
cc      DATA DLRI/0.09336,.0035,0.188,.023/    ! radiation  length(m)
cc     +    ,DLYI/.455, .096, .400, .162/      ! nuclear length(m)
cc     +    ,AI /0.96E-7, 0.56E-7, 0.63E-7, 1.E-7/  !Si110 1/2 interplan. dist. mm
cc     +    ,DES/0.56,  3.0,  0.6, 1./         ! energy deposition in subst(GeV/m)
cc     +    ,DLAI/1.6,  0.57, 2.2, 1.0/        ! elastic length(m)
cc     +    ,SAI /42.,  140.,  42., 50./       ! elastic scat. r.m.s(mr)
cc     +    ,eUm/21.34,  21.,   21.,   21./    ! only for Si(110) potent. [eV]
cc      END





      

C                        'MATH.F'   10.07.01
C1  RANNOR - Gauss distribution simulation procedure.
C2  RF RNDM- ­  [0,1]        *
C3  RNDMST - .
C4  ...
C.**************************************************************************
C     subroutine for the generation of random numbers with a gaussian
C     distribution
C.**************************************************************************
C.**************************************************************************
      SUBROUTINE RANNOR(A,B) !gaussian with mean 0 and sigma 1
C
C1    Gauss distribution simulation procedure
C
      Y = RNDM(1.)
      IF (Y .EQ. 0.) Y = RNDM(1.)
      Z = RNDM(1.)
      X = 6.2831853*Z
      A1= SQRT(-2.0*ALOG(Y))
      A = A1*SIN(X)
      B = A1*COS(X)
C
      RETURN
      END
C
      real*4 function RNDM(rdummy)
      REAL*4          u,c,cd,cm, rrdummy
      COMMON/RANDOM/  u(97),c,cd,cm,i,j
C
      rrdummy = rdummy
C
      RNDM = u(i)-u(j)
      if (RNDM .LT. 0.) RNDM = RNDM+1.
      U(i) = RNDM
      i = i-1
      if ( i .EQ. 0 ) i = 97
      j = j-1
      if ( j .EQ. 0 ) j = 97
      c = c-cd
      if ( C .LT. 0.) c = c+cm
      RNDM = RNDM - c
      if ( RNDM .LT. 0. ) RNDM = RNDM+1.
C
      return
      END
C.**************************************************************************
C
C.**************************************************************************
      subroutine RNDMST(NA1,NA2,NA3,NB1)
      REAL*4 u,c,cd,cm
      COMMON/RANDOM/ u(97),c,cd,cm,i,j
C
      ma1 = na1
      ma2 = na2
      ma3 = na3
      mb1 = nb1
      i   = 97
      j   = 33
C
      do ii2 = 1,97
        s = 0.0
        t = 0.5
        do ii1 = 1,24
          mat  = MOD(MOD(ma1*ma2,179)*ma3,179)
          ma1  = ma2
          ma2  = ma3
          ma3  = mat
          mb1  = MOD(53*mb1+1,169)
          if (MOD(MB1*MAT,64) .GE. 32 ) s = s+t
          t = 0.5*t
        end do
        u(ii2) = s
      end do
C
      c  =   362436./16777216.
      cd =  7654321./16777216.
      cm = 16777213./16777216.
C
      return
      END
C.**************************************************************************
C
C.**************************************************************************
      subroutine RNDMIN(uin,cin,cdin,cmin,iin,jin)
      REAL*4 uin(97),cin,cdin,cmin
      REAL*4 u,c,cd,cm
      COMMON/RANDOM/ u(97),c,cd,cm,i,j
C
      do kkk = 1,97
        u(kkk) = uin(kkk)
      end do
C
      c  = cin
      cd = cdin
      cm = cmin
      i  = iin
      j  = jin
C
      return
      END
C.**************************************************************************
C
C.**************************************************************************
      subroutine RNDMOU(UOUT,COUT,CDOUT,CMOUT,IOUT,JOUT)
      REAL*4 uout(97),cout,cdout,cmout
      REAL*4 u,c,cd,cm
      COMMON/RANDOM/ u(97),c,cd,cm,i,j
C
      do kkk = 1,97
        uout(kkk) = u(kkk)
      end do
C
      COUT  = C
      CDOUT = CD
      CMOUT = CM
      IOUT  = I
      JOUT  = J
C
      return
      END
C.**************************************************************************
C
C.**************************************************************************
      subroutine RNDMTE(IO)
C
C.    *******************************************************************
C.    *  SUBROUTINE RNDMTE(IO)                                          
C.    *******************************************************************
C
      REAL*4 uu(97)
      REAL*4 u(6),x(6),d(6)
      DATA u / 6533892.0 , 14220222.0 ,  7275067.0 ,
     +         6172232.0 ,  8354498.0 , 10633180.0 /
C
      call RNDMOU(UU,CC,CCD,CCM,II,JJ)
      call RNDMST(12,34,56,78)
C
      do ii1 = 1,20000
        xx = rndm4()
      end do
C
      sd = 0.0
      do ii2 = 1,6
        x(II2)  = 4096.*(4096.*rndm4())
        d(II2)  = x(II2)-u(II2)
        sd = sd+d(II2)
      end do
C
      call RNDMIN(uu,cc,ccd,ccm,ii,jj)
      if (IO.EQ.1 .OR. SD .NE. 0.) write(6,10) (u(I),x(I),d(I),i=1,6)
C
 10   format('  === TEST OF THE RANDOM-GENERATOR ===',/,
     +       '    EXPECTED VALUE    CALCULATED VALUE     DIFFERENCE',/,
     +       6(F17.1,F20.1,F15.3,/),
     +       '  === END OF TEST ;',
     +       '  GENERATOR HAS THE SAME STATUS AS BEFORE CALLING RNDMTE')
      return
      END


